#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SouthSeaTreasureHuntRewardCFG.h"
std::auto_ptr<Fish_SouthSeaTreasureHuntRewardCFG> Fish_SouthSeaTreasureHuntRewardCFG::msSingleton(nullptr);

int Fish_SouthSeaTreasureHuntRewardCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SouthSeaTreasureHuntRewardCFGData* Fish_SouthSeaTreasureHuntRewardCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SouthSeaTreasureHuntRewardCFGData>& Fish_SouthSeaTreasureHuntRewardCFG::GetMapData()
{
	return mMapData;
}

void Fish_SouthSeaTreasureHuntRewardCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SouthSeaTreasureHuntRewardCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SouthSeaTreasureHuntRewardCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomId = element->IntAttribute("RoomId");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		data.mWeight = element->IntAttribute("Weight");
		data.mFirst = element->IntAttribute("First");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SouthSeaTreasureHuntRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SouthSeaTreasureHuntRewardCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SouthSeaTreasureHuntRewardCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SouthSeaTreasureHuntRewardCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SouthSeaTreasureHuntRewardCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RoomId", data.mRoomId);
		LuaCfgHelper::readVectorInt(L, "RewardList", data.mRewardList);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "First", data.mFirst);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SouthSeaTreasureHuntRewardCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SouthSeaTreasureHuntRewardCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SouthSeaTreasureHuntRewardCFG* Fish_SouthSeaTreasureHuntRewardCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SouthSeaTreasureHuntRewardCFG());
	}
	return msSingleton.get();
}

void Fish_SouthSeaTreasureHuntRewardCFG::Release()
{
	msSingleton.reset(nullptr);
}
